import React__default, { createContext, createElement, Fragment as Fragment$1, forwardRef, useReducer, useEffect, useState, useRef, useCallback } from 'react';
import styled, { ThemeProvider as ThemeProvider$1 } from 'styled-components';
import Tooltip from 'react-tooltip';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}var AsyncMode=l;var ConcurrentMode=m;var ContextConsumer=k;var ContextProvider=h;var Element=c;var ForwardRef=n;var Fragment=e;var Lazy=t;var Memo=r;var Portal=d;
var Profiler=g;var StrictMode=f;var Suspense=p;var isAsyncMode=function(a){return A(a)||z(a)===l};var isConcurrentMode=A;var isContextConsumer=function(a){return z(a)===k};var isContextProvider=function(a){return z(a)===h};var isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};var isForwardRef=function(a){return z(a)===n};var isFragment=function(a){return z(a)===e};var isLazy=function(a){return z(a)===t};
var isMemo=function(a){return z(a)===r};var isPortal=function(a){return z(a)===d};var isProfiler=function(a){return z(a)===g};var isStrictMode=function(a){return z(a)===f};var isSuspense=function(a){return z(a)===p};
var isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};var typeOf=z;

var reactIs_production_min = {
	AsyncMode: AsyncMode,
	ConcurrentMode: ConcurrentMode,
	ContextConsumer: ContextConsumer,
	ContextProvider: ContextProvider,
	Element: Element,
	ForwardRef: ForwardRef,
	Fragment: Fragment,
	Lazy: Lazy,
	Memo: Memo,
	Portal: Portal,
	Profiler: Profiler,
	StrictMode: StrictMode,
	Suspense: Suspense,
	isAsyncMode: isAsyncMode,
	isConcurrentMode: isConcurrentMode,
	isContextConsumer: isContextConsumer,
	isContextProvider: isContextProvider,
	isElement: isElement,
	isForwardRef: isForwardRef,
	isFragment: isFragment,
	isLazy: isLazy,
	isMemo: isMemo,
	isPortal: isPortal,
	isProfiler: isProfiler,
	isStrictMode: isStrictMode,
	isSuspense: isSuspense,
	isValidElementType: isValidElementType,
	typeOf: typeOf
};

var reactIs_development = createCommonjsModule(function (module, exports) {



if (process.env.NODE_ENV !== "production") {
  (function() {

// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
// nor polyfill, then a plain number is used for performance.
var hasSymbol = typeof Symbol === 'function' && Symbol.for;
var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
// (unstable) APIs that have been removed. Can we remove the symbols?

var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

function isValidElementType(type) {
  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
}

function typeOf(object) {
  if (typeof object === 'object' && object !== null) {
    var $$typeof = object.$$typeof;

    switch ($$typeof) {
      case REACT_ELEMENT_TYPE:
        var type = object.type;

        switch (type) {
          case REACT_ASYNC_MODE_TYPE:
          case REACT_CONCURRENT_MODE_TYPE:
          case REACT_FRAGMENT_TYPE:
          case REACT_PROFILER_TYPE:
          case REACT_STRICT_MODE_TYPE:
          case REACT_SUSPENSE_TYPE:
            return type;

          default:
            var $$typeofType = type && type.$$typeof;

            switch ($$typeofType) {
              case REACT_CONTEXT_TYPE:
              case REACT_FORWARD_REF_TYPE:
              case REACT_LAZY_TYPE:
              case REACT_MEMO_TYPE:
              case REACT_PROVIDER_TYPE:
                return $$typeofType;

              default:
                return $$typeof;
            }

        }

      case REACT_PORTAL_TYPE:
        return $$typeof;
    }
  }

  return undefined;
} // AsyncMode is deprecated along with isAsyncMode

var AsyncMode = REACT_ASYNC_MODE_TYPE;
var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
var ContextConsumer = REACT_CONTEXT_TYPE;
var ContextProvider = REACT_PROVIDER_TYPE;
var Element = REACT_ELEMENT_TYPE;
var ForwardRef = REACT_FORWARD_REF_TYPE;
var Fragment = REACT_FRAGMENT_TYPE;
var Lazy = REACT_LAZY_TYPE;
var Memo = REACT_MEMO_TYPE;
var Portal = REACT_PORTAL_TYPE;
var Profiler = REACT_PROFILER_TYPE;
var StrictMode = REACT_STRICT_MODE_TYPE;
var Suspense = REACT_SUSPENSE_TYPE;
var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

function isAsyncMode(object) {
  {
    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
    }
  }

  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
}
function isConcurrentMode(object) {
  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
}
function isContextConsumer(object) {
  return typeOf(object) === REACT_CONTEXT_TYPE;
}
function isContextProvider(object) {
  return typeOf(object) === REACT_PROVIDER_TYPE;
}
function isElement(object) {
  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
}
function isForwardRef(object) {
  return typeOf(object) === REACT_FORWARD_REF_TYPE;
}
function isFragment(object) {
  return typeOf(object) === REACT_FRAGMENT_TYPE;
}
function isLazy(object) {
  return typeOf(object) === REACT_LAZY_TYPE;
}
function isMemo(object) {
  return typeOf(object) === REACT_MEMO_TYPE;
}
function isPortal(object) {
  return typeOf(object) === REACT_PORTAL_TYPE;
}
function isProfiler(object) {
  return typeOf(object) === REACT_PROFILER_TYPE;
}
function isStrictMode(object) {
  return typeOf(object) === REACT_STRICT_MODE_TYPE;
}
function isSuspense(object) {
  return typeOf(object) === REACT_SUSPENSE_TYPE;
}

exports.AsyncMode = AsyncMode;
exports.ConcurrentMode = ConcurrentMode;
exports.ContextConsumer = ContextConsumer;
exports.ContextProvider = ContextProvider;
exports.Element = Element;
exports.ForwardRef = ForwardRef;
exports.Fragment = Fragment;
exports.Lazy = Lazy;
exports.Memo = Memo;
exports.Portal = Portal;
exports.Profiler = Profiler;
exports.StrictMode = StrictMode;
exports.Suspense = Suspense;
exports.isAsyncMode = isAsyncMode;
exports.isConcurrentMode = isConcurrentMode;
exports.isContextConsumer = isContextConsumer;
exports.isContextProvider = isContextProvider;
exports.isElement = isElement;
exports.isForwardRef = isForwardRef;
exports.isFragment = isFragment;
exports.isLazy = isLazy;
exports.isMemo = isMemo;
exports.isPortal = isPortal;
exports.isProfiler = isProfiler;
exports.isStrictMode = isStrictMode;
exports.isSuspense = isSuspense;
exports.isValidElementType = isValidElementType;
exports.typeOf = typeOf;
  })();
}
});

var reactIs = createCommonjsModule(function (module) {

if (process.env.NODE_ENV === 'production') {
  module.exports = reactIs_production_min;
} else {
  module.exports = reactIs_development;
}
});

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
/* eslint-disable no-unused-vars */
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

var ReactPropTypesSecret_1 = ReactPropTypesSecret;

var printWarning = function() {};

if (process.env.NODE_ENV !== 'production') {
  var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
  var loggedTypeFailures = {};
  var has = Function.call.bind(Object.prototype.hasOwnProperty);

  printWarning = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

/**
 * Assert that the values match with the type specs.
 * Error messages are memorized and will only be shown once.
 *
 * @param {object} typeSpecs Map of name to a ReactPropType
 * @param {object} values Runtime values that need to be type-checked
 * @param {string} location e.g. "prop", "context", "child context"
 * @param {string} componentName Name of the component for error messages.
 * @param {?Function} getStack Returns the component stack.
 * @private
 */
function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
  if (process.env.NODE_ENV !== 'production') {
    for (var typeSpecName in typeSpecs) {
      if (has(typeSpecs, typeSpecName)) {
        var error;
        // Prop type validation may throw. In case they do, we don't want to
        // fail the render phase where it didn't fail before. So we log it.
        // After these have been cleaned up, we'll let them throw.
        try {
          // This is intentionally an invariant that gets caught. It's the same
          // behavior as without this statement except with a better message.
          if (typeof typeSpecs[typeSpecName] !== 'function') {
            var err = Error(
              (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
              'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
            );
            err.name = 'Invariant Violation';
            throw err;
          }
          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
        } catch (ex) {
          error = ex;
        }
        if (error && !(error instanceof Error)) {
          printWarning(
            (componentName || 'React class') + ': type specification of ' +
            location + ' `' + typeSpecName + '` is invalid; the type checker ' +
            'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
            'You may have forgotten to pass an argument to the type checker ' +
            'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
            'shape all require an argument).'
          );
        }
        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
          // Only monitor this failure once because there tends to be a lot of the
          // same error.
          loggedTypeFailures[error.message] = true;

          var stack = getStack ? getStack() : '';

          printWarning(
            'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
          );
        }
      }
    }
  }
}

/**
 * Resets warning cache when testing.
 *
 * @private
 */
checkPropTypes.resetWarningCache = function() {
  if (process.env.NODE_ENV !== 'production') {
    loggedTypeFailures = {};
  }
};

var checkPropTypes_1 = checkPropTypes;

var has$1 = Function.call.bind(Object.prototype.hasOwnProperty);
var printWarning$1 = function() {};

if (process.env.NODE_ENV !== 'production') {
  printWarning$1 = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

function emptyFunctionThatReturnsNull() {
  return null;
}

var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
  /* global Symbol */
  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

  /**
   * Returns the iterator method function contained on the iterable object.
   *
   * Be sure to invoke the function with the iterable as context:
   *
   *     var iteratorFn = getIteratorFn(myIterable);
   *     if (iteratorFn) {
   *       var iterator = iteratorFn.call(myIterable);
   *       ...
   *     }
   *
   * @param {?object} maybeIterable
   * @return {?function}
   */
  function getIteratorFn(maybeIterable) {
    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
    if (typeof iteratorFn === 'function') {
      return iteratorFn;
    }
  }

  /**
   * Collection of methods that allow declaration and validation of props that are
   * supplied to React components. Example usage:
   *
   *   var Props = require('ReactPropTypes');
   *   var MyArticle = React.createClass({
   *     propTypes: {
   *       // An optional string prop named "description".
   *       description: Props.string,
   *
   *       // A required enum prop named "category".
   *       category: Props.oneOf(['News','Photos']).isRequired,
   *
   *       // A prop named "dialog" that requires an instance of Dialog.
   *       dialog: Props.instanceOf(Dialog).isRequired
   *     },
   *     render: function() { ... }
   *   });
   *
   * A more formal specification of how these methods are used:
   *
   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
   *   decl := ReactPropTypes.{type}(.isRequired)?
   *
   * Each and every declaration produces a function with the same signature. This
   * allows the creation of custom validation functions. For example:
   *
   *  var MyLink = React.createClass({
   *    propTypes: {
   *      // An optional string or URI prop named "href".
   *      href: function(props, propName, componentName) {
   *        var propValue = props[propName];
   *        if (propValue != null && typeof propValue !== 'string' &&
   *            !(propValue instanceof URI)) {
   *          return new Error(
   *            'Expected a string or an URI for ' + propName + ' in ' +
   *            componentName
   *          );
   *        }
   *      }
   *    },
   *    render: function() {...}
   *  });
   *
   * @internal
   */

  var ANONYMOUS = '<<anonymous>>';

  // Important!
  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
  var ReactPropTypes = {
    array: createPrimitiveTypeChecker('array'),
    bool: createPrimitiveTypeChecker('boolean'),
    func: createPrimitiveTypeChecker('function'),
    number: createPrimitiveTypeChecker('number'),
    object: createPrimitiveTypeChecker('object'),
    string: createPrimitiveTypeChecker('string'),
    symbol: createPrimitiveTypeChecker('symbol'),

    any: createAnyTypeChecker(),
    arrayOf: createArrayOfTypeChecker,
    element: createElementTypeChecker(),
    elementType: createElementTypeTypeChecker(),
    instanceOf: createInstanceTypeChecker,
    node: createNodeChecker(),
    objectOf: createObjectOfTypeChecker,
    oneOf: createEnumTypeChecker,
    oneOfType: createUnionTypeChecker,
    shape: createShapeTypeChecker,
    exact: createStrictShapeTypeChecker,
  };

  /**
   * inlined Object.is polyfill to avoid requiring consumers ship their own
   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
   */
  /*eslint-disable no-self-compare*/
  function is(x, y) {
    // SameValue algorithm
    if (x === y) {
      // Steps 1-5, 7-10
      // Steps 6.b-6.e: +0 != -0
      return x !== 0 || 1 / x === 1 / y;
    } else {
      // Step 6.a: NaN == NaN
      return x !== x && y !== y;
    }
  }
  /*eslint-enable no-self-compare*/

  /**
   * We use an Error-like object for backward compatibility as people may call
   * PropTypes directly and inspect their output. However, we don't use real
   * Errors anymore. We don't inspect their stack anyway, and creating them
   * is prohibitively expensive if they are created too often, such as what
   * happens in oneOfType() for any type before the one that matched.
   */
  function PropTypeError(message) {
    this.message = message;
    this.stack = '';
  }
  // Make `instanceof Error` still work for returned errors.
  PropTypeError.prototype = Error.prototype;

  function createChainableTypeChecker(validate) {
    if (process.env.NODE_ENV !== 'production') {
      var manualPropTypeCallCache = {};
      var manualPropTypeWarningCount = 0;
    }
    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
      componentName = componentName || ANONYMOUS;
      propFullName = propFullName || propName;

      if (secret !== ReactPropTypesSecret_1) {
        if (throwOnDirectAccess) {
          // New behavior only for users of `prop-types` package
          var err = new Error(
            'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
            'Use `PropTypes.checkPropTypes()` to call them. ' +
            'Read more at http://fb.me/use-check-prop-types'
          );
          err.name = 'Invariant Violation';
          throw err;
        } else if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
          // Old behavior for people using React.PropTypes
          var cacheKey = componentName + ':' + propName;
          if (
            !manualPropTypeCallCache[cacheKey] &&
            // Avoid spamming the console because they are often not actionable except for lib authors
            manualPropTypeWarningCount < 3
          ) {
            printWarning$1(
              'You are manually calling a React.PropTypes validation ' +
              'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
              'and will throw in the standalone `prop-types` package. ' +
              'You may be seeing this warning due to a third-party PropTypes ' +
              'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
            );
            manualPropTypeCallCache[cacheKey] = true;
            manualPropTypeWarningCount++;
          }
        }
      }
      if (props[propName] == null) {
        if (isRequired) {
          if (props[propName] === null) {
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
          }
          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
        }
        return null;
      } else {
        return validate(props, propName, componentName, location, propFullName);
      }
    }

    var chainedCheckType = checkType.bind(null, false);
    chainedCheckType.isRequired = checkType.bind(null, true);

    return chainedCheckType;
  }

  function createPrimitiveTypeChecker(expectedType) {
    function validate(props, propName, componentName, location, propFullName, secret) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== expectedType) {
        // `propValue` being instance of, say, date/regexp, pass the 'object'
        // check, but we can offer a more precise error message here rather than
        // 'of type `object`'.
        var preciseType = getPreciseType(propValue);

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createAnyTypeChecker() {
    return createChainableTypeChecker(emptyFunctionThatReturnsNull);
  }

  function createArrayOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
      }
      var propValue = props[propName];
      if (!Array.isArray(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
      }
      for (var i = 0; i < propValue.length; i++) {
        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
        if (error instanceof Error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!isValidElement(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!reactIs.isValidElementType(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement type.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createInstanceTypeChecker(expectedClass) {
    function validate(props, propName, componentName, location, propFullName) {
      if (!(props[propName] instanceof expectedClass)) {
        var expectedClassName = expectedClass.name || ANONYMOUS;
        var actualClassName = getClassName(props[propName]);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createEnumTypeChecker(expectedValues) {
    if (!Array.isArray(expectedValues)) {
      if (process.env.NODE_ENV !== 'production') {
        if (arguments.length > 1) {
          printWarning$1(
            'Invalid arguments supplied to oneOf, expected an array, got ' + arguments.length + ' arguments. ' +
            'A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z]).'
          );
        } else {
          printWarning$1('Invalid argument supplied to oneOf, expected an array.');
        }
      }
      return emptyFunctionThatReturnsNull;
    }

    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      for (var i = 0; i < expectedValues.length; i++) {
        if (is(propValue, expectedValues[i])) {
          return null;
        }
      }

      var valuesString = JSON.stringify(expectedValues, function replacer(key, value) {
        var type = getPreciseType(value);
        if (type === 'symbol') {
          return String(value);
        }
        return value;
      });
      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + String(propValue) + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createObjectOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
      }
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
      }
      for (var key in propValue) {
        if (has$1(propValue, key)) {
          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error instanceof Error) {
            return error;
          }
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createUnionTypeChecker(arrayOfTypeCheckers) {
    if (!Array.isArray(arrayOfTypeCheckers)) {
      process.env.NODE_ENV !== 'production' ? printWarning$1('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
      return emptyFunctionThatReturnsNull;
    }

    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
      var checker = arrayOfTypeCheckers[i];
      if (typeof checker !== 'function') {
        printWarning$1(
          'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
          'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
        );
        return emptyFunctionThatReturnsNull;
      }
    }

    function validate(props, propName, componentName, location, propFullName) {
      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
          return null;
        }
      }

      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createNodeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      if (!isNode(props[propName])) {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      for (var key in shapeTypes) {
        var checker = shapeTypes[key];
        if (!checker) {
          continue;
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createStrictShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      // We need to check all keys in case some are required but missing from
      // props.
      var allKeys = objectAssign({}, props[propName], shapeTypes);
      for (var key in allKeys) {
        var checker = shapeTypes[key];
        if (!checker) {
          return new PropTypeError(
            'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
            '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
            '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
          );
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }

    return createChainableTypeChecker(validate);
  }

  function isNode(propValue) {
    switch (typeof propValue) {
      case 'number':
      case 'string':
      case 'undefined':
        return true;
      case 'boolean':
        return !propValue;
      case 'object':
        if (Array.isArray(propValue)) {
          return propValue.every(isNode);
        }
        if (propValue === null || isValidElement(propValue)) {
          return true;
        }

        var iteratorFn = getIteratorFn(propValue);
        if (iteratorFn) {
          var iterator = iteratorFn.call(propValue);
          var step;
          if (iteratorFn !== propValue.entries) {
            while (!(step = iterator.next()).done) {
              if (!isNode(step.value)) {
                return false;
              }
            }
          } else {
            // Iterator will provide entry [k,v] tuples rather than values.
            while (!(step = iterator.next()).done) {
              var entry = step.value;
              if (entry) {
                if (!isNode(entry[1])) {
                  return false;
                }
              }
            }
          }
        } else {
          return false;
        }

        return true;
      default:
        return false;
    }
  }

  function isSymbol(propType, propValue) {
    // Native Symbol.
    if (propType === 'symbol') {
      return true;
    }

    // falsy value can't be a Symbol
    if (!propValue) {
      return false;
    }

    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
    if (propValue['@@toStringTag'] === 'Symbol') {
      return true;
    }

    // Fallback for non-spec compliant Symbols which are polyfilled.
    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
      return true;
    }

    return false;
  }

  // Equivalent of `typeof` but with special handling for array and regexp.
  function getPropType(propValue) {
    var propType = typeof propValue;
    if (Array.isArray(propValue)) {
      return 'array';
    }
    if (propValue instanceof RegExp) {
      // Old webkits (at least until Android 4.0) return 'function' rather than
      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
      // passes PropTypes.object.
      return 'object';
    }
    if (isSymbol(propType, propValue)) {
      return 'symbol';
    }
    return propType;
  }

  // This handles more types than `getPropType`. Only used for error messages.
  // See `createPrimitiveTypeChecker`.
  function getPreciseType(propValue) {
    if (typeof propValue === 'undefined' || propValue === null) {
      return '' + propValue;
    }
    var propType = getPropType(propValue);
    if (propType === 'object') {
      if (propValue instanceof Date) {
        return 'date';
      } else if (propValue instanceof RegExp) {
        return 'regexp';
      }
    }
    return propType;
  }

  // Returns a string that is postfixed to a warning about an invalid type.
  // For example, "undefined" or "of type array"
  function getPostfixForTypeWarning(value) {
    var type = getPreciseType(value);
    switch (type) {
      case 'array':
      case 'object':
        return 'an ' + type;
      case 'boolean':
      case 'date':
      case 'regexp':
        return 'a ' + type;
      default:
        return type;
    }
  }

  // Returns class name of the object, if any.
  function getClassName(propValue) {
    if (!propValue.constructor || !propValue.constructor.name) {
      return ANONYMOUS;
    }
    return propValue.constructor.name;
  }

  ReactPropTypes.checkPropTypes = checkPropTypes_1;
  ReactPropTypes.resetWarningCache = checkPropTypes_1.resetWarningCache;
  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

function emptyFunction() {}
function emptyFunctionWithReset() {}
emptyFunctionWithReset.resetWarningCache = emptyFunction;

var factoryWithThrowingShims = function() {
  function shim(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret_1) {
      // It is still safe when called from React.
      return;
    }
    var err = new Error(
      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
      'Use PropTypes.checkPropTypes() to call them. ' +
      'Read more at http://fb.me/use-check-prop-types'
    );
    err.name = 'Invariant Violation';
    throw err;
  }  shim.isRequired = shim;
  function getShim() {
    return shim;
  }  // Important!
  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
  var ReactPropTypes = {
    array: shim,
    bool: shim,
    func: shim,
    number: shim,
    object: shim,
    string: shim,
    symbol: shim,

    any: shim,
    arrayOf: getShim,
    element: shim,
    elementType: shim,
    instanceOf: getShim,
    node: shim,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim,
    exact: getShim,

    checkPropTypes: emptyFunctionWithReset,
    resetWarningCache: emptyFunction
  };

  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

var propTypes = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

if (process.env.NODE_ENV !== 'production') {
  var ReactIs = reactIs;

  // By explicitly using `prop-types` you are opting into new development behavior.
  // http://fb.me/prop-types-in-prod
  var throwOnDirectAccess = true;
  module.exports = factoryWithTypeCheckers(ReactIs.isElement, throwOnDirectAccess);
} else {
  // By explicitly using `prop-types` you are opting into new production behavior.
  // http://fb.me/prop-types-in-prod
  module.exports = factoryWithThrowingShims();
}
});

var createRange = function createRange(n) {
  return Array.from(Array(n).keys());
};

var DefaultContext = {
  color: undefined,
  size: undefined,
  className: undefined,
  style: undefined,
  attr: undefined
};
var IconContext = createContext && createContext(DefaultContext);

var __assign = undefined && undefined.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = undefined && undefined.__rest || function (s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
  return t;
};

function Tree2Element(tree) {
  return tree && tree.map(function (node, i) {
    return createElement(node.tag, __assign({
      key: i
    }, node.attr), Tree2Element(node.child));
  });
}

function GenIcon(data) {
  return function (props) {
    return createElement(IconBase, __assign({
      attr: __assign({}, data.attr)
    }, props), Tree2Element(data.child));
  };
}
function IconBase(props) {
  var elem = function (conf) {
    var computedSize = props.size || conf.size || "1em";
    var className;
    if (conf.className) className = conf.className;
    if (props.className) className = (className ? className + ' ' : '') + props.className;

    var attr = props.attr,
        title = props.title,
        svgProps = __rest(props, ["attr", "title"]);

    return createElement("svg", __assign({
      stroke: "currentColor",
      fill: "currentColor",
      strokeWidth: "0"
    }, conf.attr, attr, svgProps, {
      className: className,
      style: __assign({
        color: props.color || conf.color
      }, conf.style, props.style),
      height: computedSize,
      width: computedSize,
      xmlns: "http://www.w3.org/2000/svg"
    }), title && createElement("title", null, title), props.children);
  };

  return IconContext !== undefined ? createElement(IconContext.Consumer, null, function (conf) {
    return elem(conf);
  }) : elem(DefaultContext);
}

// THIS FILE IS AUTO GENERATED
function FaAngleLeft (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 256 512"},"child":[{"tag":"path","attr":{"d":"M31.7 239l136-136c9.4-9.4 24.6-9.4 33.9 0l22.6 22.6c9.4 9.4 9.4 24.6 0 33.9L127.9 256l96.4 96.4c9.4 9.4 9.4 24.6 0 33.9L201.7 409c-9.4 9.4-24.6 9.4-33.9 0l-136-136c-9.5-9.4-9.5-24.6-.1-34z"}}]})(props);
}function FaAngleRight (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 256 512"},"child":[{"tag":"path","attr":{"d":"M224.3 273l-136 136c-9.4 9.4-24.6 9.4-33.9 0l-22.6-22.6c-9.4-9.4-9.4-24.6 0-33.9l96.4-96.4-96.4-96.4c-9.4-9.4-9.4-24.6 0-33.9L54.3 103c9.4-9.4 24.6-9.4 33.9 0l136 136c9.5 9.4 9.5 24.6.1 34z"}}]})(props);
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  .btn {\n    width: 30px;\n    height: 30px;\n    border: 2px solid;\n    border-radius: 50%;\n    font-size: 1.5rem;\n    transition: 0.15s;\n    opacity: 0.65;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n\n    &:hover,\n    &:focus {\n      opacity: 1;\n      cursor: pointer;\n    }\n\n    &-icon {\n      /* position: absolute;\n      top: 50%;\n      left: 50%;\n      transform: translate(-50%, -50%); */\n    }\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function Button(_ref) {
  var isPrev = _ref.isPrev,
      onClick = _ref.onClick,
      restProps = _objectWithoutPropertiesLoose(_ref, ["isPrev", "onClick"]);

  var content = isPrev ? 'slide backwards' : 'slide forward';
  return /*#__PURE__*/React__default.createElement(Styled, {
    isPrev: isPrev
  }, /*#__PURE__*/React__default.createElement("button", _extends({}, restProps, {
    className: "btn " + (isPrev ? 'btn--prev' : 'btn--next'),
    role: "caret-button",
    "aria-label": isPrev ? 'prev button' : 'next button',
    onClick: onClick,
    "data-tip": content,
    "data-for": "btn"
  }), isPrev ? /*#__PURE__*/React__default.createElement(FaAngleLeft, {
    className: "btn-icon"
  }) : /*#__PURE__*/React__default.createElement(FaAngleRight, {
    className: "btn-icon"
  })), /*#__PURE__*/React__default.createElement(Tooltip, {
    id: "btn"
  }));
}

var Styled = styled.div(_templateObject());

var getTranslateXRanges = function getTranslateXRanges(dot, slidesToShow) {
  var currentTranslateXRange, nextTranslateXRange;

  if (!dot) {
    currentTranslateXRange = -(dot * 100);
    nextTranslateXRange = -((dot + slidesToShow) * 100);
  } else {
    currentTranslateXRange = -(dot * (slidesToShow * 100));
    nextTranslateXRange = -((dot + 1) * (slidesToShow * 100));
  }

  return {
    currentTranslateXRange: currentTranslateXRange,
    nextTranslateXRange: nextTranslateXRange
  };
};
var strippedNum = function strippedNum(n) {
  return Number(("" + n).replace(/^-/, '')) / 100;
};

function Dots(_ref) {
  var _ref$data = _ref.data,
      dots = _ref$data.dots,
      slidesToShow = _ref$data.slidesToShow,
      translateX = _ref$data.translateX,
      currentDot = _ref$data.currentDot,
      _onClick = _ref.onClick,
      restProps = _objectWithoutPropertiesLoose(_ref, ["data", "onClick"]);

  var formatDotClassName = function formatDotClassName(dot) {
    var className = 'dot';

    if (translateX !== undefined && slidesToShow !== undefined) {
      var _getTranslateXRanges = getTranslateXRanges(dot, slidesToShow),
          currentTranslateXRange = _getTranslateXRanges.currentTranslateXRange,
          nextTranslateXRange = _getTranslateXRanges.nextTranslateXRange;

      var dotIsWithinTransLateXRange = translateX <= currentTranslateXRange && translateX > nextTranslateXRange;

      if (dotIsWithinTransLateXRange) {
        className += ' dot--active';
      }
    } else {
      if (dot === currentDot) {
        className += ' dot--active';
      }
    }

    return className;
  };

  return /*#__PURE__*/React__default.createElement("div", _extends({
    className: "dots",
    "data-testid": "dots"
  }, restProps), dots.map(function (dot, index) {
    return /*#__PURE__*/React__default.createElement(Fragment$1, {
      key: dot
    }, /*#__PURE__*/React__default.createElement("button", {
      role: "dot-button",
      onClick: function onClick() {
        return _onClick(dot);
      },
      className: formatDotClassName(dot),
      "data-tip": "slide to #" + (index + 1),
      "data-for": "dot " + index
    }), /*#__PURE__*/React__default.createElement(Tooltip, {
      id: "dot " + index
    }));
  }));
}

var Slide = forwardRef(function (_ref, ref) {
  var _ref$data = _ref.data,
      translateX = _ref$data.translateX,
      transition = _ref$data.transition,
      slide = _ref$data.slide,
      style = _ref.style,
      restProps = _objectWithoutPropertiesLoose(_ref, ["data", "style"]);

  return /*#__PURE__*/React__default.createElement("article", _extends({
    ref: ref
  }, restProps, {
    className: "slide",
    "data-testid": "slide",
    style: _extends({
      transform: "translateX(" + translateX + "%)",
      transition: transition
    }, style)
  }), slide);
});

function _templateObject$1() {
  var data = _taggedTemplateLiteralLoose(["\n  /* border: 3px solid red; */\n  position: relative;\n  display: flex;\n  align-items: center;\n  width: 100%;\n  box-sizing: border-box;\n  overflow: hidden;\n  margin: 0;\n  padding: 0;\n\n  .content {\n    flex: 1;\n    overflow: hidden;\n\n    .center {\n      /* border: 2px solid blue; */\n      display: flex;\n      box-sizing: border-box;\n      overflow: hidden;\n\n      .slide {\n        /* border: 1px solid gold; */\n        box-sizing: border-box;\n        flex: 1 0 ", ";\n      }\n    }\n\n    .dots {\n      /* border: 1px solid green; */\n      min-height: 16px;\n      display: flex;\n      align-items: center;\n      justify-content: center;\n      /* overflow: hidden; */\n\n      .dot {\n        border: none;\n        display: block;\n        border-radius: 10em;\n        margin: 0 0.1875rem;\n        padding: 3.5px 12.5px;\n        background-color: ", ";\n        transition: 0.3s ease;\n        flex: 0;\n\n        &--active {\n          /* transform: scaleX(1.5); */\n          border-radius: 50px;\n          background-color: ", ";\n        }\n\n        &:hover {\n          background-color: ", ";\n          cursor: pointer;\n        }\n\n        &:focus {\n          transform: scaleX(1);\n          background-color: ", ";\n          outline: none;\n        }\n\n        &:active {\n          opacity: 0.8;\n        }\n      }\n    }\n  }\n\n  .btn {\n    position: ", ";\n    transform: ", ";\n    top: 50%;\n    color: ", ";\n    background-color: ", ";\n\n    &--next {\n      right: 8px;\n    }\n    &--prev {\n      left: 8px;\n    }\n  }\n"]);

  _templateObject$1 = function _templateObject() {
    return data;
  };

  return data;
}
var Styled$1 = styled.div(_templateObject$1(), function (_ref) {
  var flexBasis = _ref.flexBasis;
  return flexBasis;
}, function (_ref2) {
  var theme = _ref2.theme;
  return theme.dots['2'];
}, function (_ref3) {
  var theme = _ref3.theme;
  return theme.dots['1'];
}, function (_ref4) {
  var theme = _ref4.theme;
  return theme.dots['1'];
}, function (_ref5) {
  var theme = _ref5.theme;
  return theme.dots['1'];
}, function (_ref6) {
  var fader = _ref6.fader;
  return fader ? 'absolute' : 'unset';
}, function (_ref7) {
  var fader = _ref7.fader;
  return fader ? 'translateY(-50%)' : 'none';
}, function (_ref8) {
  var theme = _ref8.theme;
  return theme.carets['1'];
}, function (_ref9) {
  var theme = _ref9.theme;
  return theme.carets['2'];
});
Styled$1.defaultProps = {
  theme: {
    dots: {
      1: '#333',
      2: '#3332'
    },
    carets: {
      1: '#333',
      2: 'transparent'
    }
  }
};

var useSwipe = function useSwipe(container) {
  var initialState = {
    hold: 0,
    movedLeft: 0,
    movedRight: 0
  };

  var reducer = function reducer(state, action) {

    switch (action) {
      case 'MOVE_LEFT':
        return {
          movedLeft: 1,
          movedRight: 0
        };

      case 'MOVE_RIGHT':
        return {
          movedRight: 1,
          movedLeft: 0
        };
    }
  };

  var _useReducer = useReducer(reducer, initialState),
      state = _useReducer[0],
      dispatch = _useReducer[1];

  useEffect(function () {
    if (container) {
      var getTouches = function getTouches(evt) {
        return evt.touches || evt.originalEvent.touches;
      };

      var handleTouchStart = function handleTouchStart(evt) {
        var firstTouch = getTouches(evt)[0];
        xDown = firstTouch.clientX;
      };

      var handleTouchMove = function handleTouchMove(evt) {
        if (!xDown) {
          return;
        }

        var xUp = evt.touches[0].clientX;
        var xDiff = xDown - xUp;

        if (xDiff > 0) {
          dispatch('MOVE_LEFT');
        } else {
          dispatch('MOVE_RIGHT');
        }

        xDown = 0;
      };

      container.addEventListener('touchstart', handleTouchStart, false);
      container.addEventListener('touchmove', handleTouchMove, false);
      var xDown = 0;
    }
  }, [container]);
  return [state, dispatch];
};

function Slider(_ref) {
  var slides = _ref.children,
      propSlidesToShow = _ref.slidesToShow,
      quickSlide = _ref.quickSlide,
      autoSlide = _ref.autoSlide,
      breakpoints = _ref.breakpoints,
      dots = _ref.dots,
      buttons = _ref.buttons,
      transition = _ref.transition;
  slides = slides && !slides.length ? [slides] : slides;

  if (!slides) {
    return null;
  }

  if (autoSlide) {
    autoSlide = _extends({
      pauseOnHover: true,
      pauseOnTab: true,
      interval: 3800
    }, autoSlide);
  }

  var _useState = useState(0),
      translateX = _useState[0],
      setTranslateX = _useState[1];

  var _useState2 = useState(0),
      nextClicks = _useState2[0],
      setNextClicks = _useState2[1];

  var _useState3 = useState(false),
      slideToPrev = _useState3[0],
      setSlideToPrev = _useState3[1];

  var _useState4 = useState(true),
      startAutoSlide = _useState4[0],
      setStartAutoSlide = _useState4[1];

  var sliderRef = useRef();
  var _slides = slides,
      slidesLength = _slides.length;

  var _useState5 = useState(propSlidesToShow),
      slidesToShow = _useState5[0],
      setSlidesToShow = _useState5[1];

  var hasAllSlidesInContainer = slidesToShow === slidesLength;
  var sliderSections = Math.ceil(slidesLength / slidesToShow);
  var dotsList = createRange(sliderSections);
  var maxTranslateX = -100 * (slidesToShow * (dotsList.length - 1));
  var maxNextClicks = dotsList.length - 1;
  var hasReachMin = quickSlide ? nextClicks === 0 : translateX === 0;
  var hasReachMax = quickSlide ? nextClicks === maxNextClicks : maxTranslateX === translateX;

  var handleDotClick = function handleDotClick(dot) {
    var _getTranslateXRanges = getTranslateXRanges(dot, slidesToShow),
        currentTranslateXRange = _getTranslateXRanges.currentTranslateXRange;

    setNextClicks(dot);
    setTranslateX(currentTranslateXRange);
  };

  var handleSlideToNext = useCallback(function () {
    if (!hasAllSlidesInContainer) {
      if (hasReachMax) {
        setNextClicks(0);
        return setTranslateX(0);
      }

      if (quickSlide) {
        setNextClicks(function (prevNextClicks) {
          return prevNextClicks + 1;
        });
        return setTranslateX(function (prevTranslateX) {
          return prevTranslateX - slidesToShow * 100;
        });
      }

      setTranslateX(function (prevTranslateX) {
        return prevTranslateX - 100;
      });
    }
  }, [hasAllSlidesInContainer, hasReachMax, quickSlide, slidesToShow]);
  var handleSlideToPrev = useCallback(function () {
    if (!hasAllSlidesInContainer) {
      if (hasReachMin) {
        setNextClicks(maxNextClicks);
        return setTranslateX(maxTranslateX);
      }

      if (quickSlide) {
        setNextClicks(function (prevNextClicks) {
          return prevNextClicks - 1;
        });
        return setTranslateX(function (prevTranslateX) {
          return prevTranslateX + slidesToShow * 100;
        });
      }

      setTranslateX(function (prevTranslateX) {
        return prevTranslateX + 100;
      });
    }
  }, [hasAllSlidesInContainer, hasReachMin, quickSlide, slidesToShow]);
  var handleMouseLeaveSlide = useCallback(function () {
    setStartAutoSlide(true);
  }, []);
  var handleMouseHoverSlide = useCallback(function () {
    setStartAutoSlide(false);
  }, []);
  useEffect(function () {
    var Slider = sliderRef.current;
    var allDocSlides = Slider.querySelectorAll('.slide');
    var allSlides = [];
    allDocSlides.forEach(function (slide) {
      return allSlides.push(slide);
    });

    var setTabIndex = function setTabIndex(nodeList, tabIndex) {
      nodeList.forEach(function (item) {
        var allFocusingElements = item.querySelectorAll('a, button, input, textarea, area');
        allFocusingElements.forEach(function (element) {
          if (autoSlide && autoSlide.pauseOnTab) {
            element.addEventListener('focus', handleMouseHoverSlide);
            element.addEventListener('blur', handleMouseLeaveSlide);
          }

          element.tabIndex = tabIndex;
        });
      });
    };

    setTabIndex(allSlides, 0);
    allSlides.splice(strippedNum(translateX), slidesToShow);
    setTabIndex(allSlides, -1);
  }, [slides, translateX, slidesToShow, handleMouseHoverSlide, handleMouseLeaveSlide]);
  useEffect(function () {
    if (autoSlide && startAutoSlide) {
      var _hasReachMax = quickSlide ? (slidesToShow + strippedNum(translateX)) * -100 === maxTranslateX : (slidesToShow + strippedNum(translateX)) * -100 === -((slidesLength - 1) * 100);

      var _hasReachMin = quickSlide ? translateX === -(slidesToShow * 100) && slideToPrev : translateX + 1 * 100 === 0;

      var intervalId = setInterval(function () {
        if (autoSlide.reverse) {
          if (_hasReachMax) {
            setSlideToPrev(true);
          }

          if (_hasReachMin) {
            setSlideToPrev(false);
          }

          if (slideToPrev) {
            handleSlideToPrev();
          } else {
            handleSlideToNext();
          }
        } else {
          handleSlideToNext();
        }
      }, autoSlide.interval);
      return function () {
        clearInterval(intervalId);
      };
    }
  }, [handleSlideToNext, handleSlideToPrev, translateX, slidesToShow, slideToPrev, autoSlide, startAutoSlide]);
  useEffect(function () {
    if (breakpoints && breakpoints.length) {
      var mappedBreakpoints = breakpoints.map(function (breakpoint) {
        return {
          width: Number(breakpoint.width),
          slidesToShow: Number(breakpoint.slidesToShow)
        };
      });
      mappedBreakpoints.forEach(function (breakpoint, index, breakpoints) {
        if (breakpoints[index + 1]) {
          var nextBreakpoint = breakpoints[index + 1];

          if (breakpoint.width > nextBreakpoint.width) {
            console.warn("'props.breakpoints[" + index + "].width' is higher than 'props.breakpoints[" + (index + 1) + "].width'. It should be the other way around or remove 'props.breakpoints[" + index + "].width'");
          }
        }
      });
      var mediaQueryMin, mediaQueryMax, handleResize;
      mappedBreakpoints.forEach(function (breakpoint) {
        mediaQueryMin = window.matchMedia("(min-width: " + breakpoint.width + "px)");
        mediaQueryMax = window.matchMedia("(max-width: " + breakpoint.width + "px)");

        handleResize = function handleResize(e) {
          if (e.matches) {
            setSlidesToShow(breakpoint.slidesToShow);
          }
        };

        handleResize(mediaQueryMin);
        mediaQueryMin.addEventListener('change', handleResize);
        mediaQueryMax.addEventListener('change', handleResize);
      });
      return function () {
        mediaQueryMin.removeEventListener('change', handleResize);
        mediaQueryMax.removeEventListener('change', handleResize);
      };
    }
  }, []);

  var _useSwipe = useSwipe(sliderRef.current),
      state = _useSwipe[0];

  useEffect(function () {
    if (state.movedLeft) {
      handleSlideToNext();
    }

    if (state.movedRight) {
      handleSlideToPrev();
    }
  }, [state]);
  var componentProps = {
    Styled: {
      flexBasis: 100 / slidesToShow + "%"
    },
    Dots: {
      data: {
        dots: dotsList,
        slidesToShow: slidesToShow,
        translateX: translateX
      },
      onClick: handleDotClick
    },
    Buttons: [{
      isPrev: true,
      onClick: handleSlideToPrev
    }, {
      isPrev: false,
      onClick: handleSlideToNext
    }],
    Slide: function Slide(slide) {
      return {
        data: {
          slide: slide,
          transition: transition,
          translateX: translateX
        }
      };
    }
  };
  return /*#__PURE__*/React__default.createElement(Styled$1, _extends({}, componentProps.Styled, {
    ref: sliderRef,
    onMouseOver: autoSlide && autoSlide.pauseOnHover ? handleMouseHoverSlide : null,
    onMouseLeave: autoSlide && autoSlide.pauseOnHover ? handleMouseLeaveSlide : null
  }), buttons && /*#__PURE__*/React__default.createElement(Button, componentProps.Buttons[0]), /*#__PURE__*/React__default.createElement("main", {
    className: "content"
  }, /*#__PURE__*/React__default.createElement("div", {
    className: "center"
  }, slides.map(function (slide, index) {
    return /*#__PURE__*/React__default.createElement(Slide, _extends({
      key: index
    }, componentProps.Slide(slide)));
  })), dots && /*#__PURE__*/React__default.createElement(Dots, componentProps.Dots)), buttons && /*#__PURE__*/React__default.createElement(Button, componentProps.Buttons[1]));
}

Slider.defaultProps = {
  slidesToShow: 1,
  buttons: true,
  dots: false,
  transition: '0.5s ease-in'
};
Slider.propTypes = {
  quickSlide: propTypes.bool,
  dots: propTypes.bool,
  buttons: propTypes.bool,
  slidesToShow: propTypes.oneOfType([propTypes.string, propTypes.number]),
  transition: propTypes.string,
  children: propTypes.oneOfType([propTypes.arrayOf(propTypes.element), propTypes.element]).isRequired,
  breakpoints: propTypes.arrayOf(propTypes.shape({
    width: propTypes.oneOfType([propTypes.string, propTypes.number]).isRequired,
    slidesToShow: propTypes.oneOfType([propTypes.string, propTypes.number]).isRequired
  })),
  autoSlide: propTypes.oneOfType([propTypes.bool, propTypes.shape({
    reverse: propTypes.bool,
    pauseOnHover: propTypes.bool,
    interval: propTypes.number
  })])
};

function Fader(_ref) {
  var slides = _ref.children,
      autoSlide = _ref.autoSlide,
      dots = _ref.dots,
      buttons = _ref.buttons,
      transition = _ref.transition;
  slides = slides && !slides.length ? [slides] : slides;

  if (!slides) {
    return null;
  }

  if (autoSlide) {
    autoSlide = _extends({
      pauseOnHover: true,
      pauseOnTab: true
    }, autoSlide);
  }

  var _useState = useState({
    slide: slides[0],
    index: 0
  }),
      currentSlideData = _useState[0],
      setCurrentSlideData = _useState[1];

  var _useState2 = useState(true),
      startAutoSlide = _useState2[0],
      setStartAutoSlide = _useState2[1];

  var sliderRef = useRef();
  var slideRef = useRef();
  var _slides = slides,
      slidesLength = _slides.length;
  var dotsList = createRange(slidesLength);
  var maxSlideIndex = slidesLength - 1;
  var hasReachMin = currentSlideData.index === 0;
  var hasReachMax = maxSlideIndex === currentSlideData.index;

  var handleDotClick = function handleDotClick(dot) {
    var slideData = _extends({}, currentSlideData);

    slideData.index = dot;
    slideData.slide = slides[slideData.index];
    setCurrentSlideData(slideData);
  };

  var handleFadeToNext = useCallback(function () {
    var slideData = _extends({}, currentSlideData);

    slideData.index += 1;

    if (hasReachMax) {
      slideData.index = 0;
    }

    slideData.slide = slides[slideData.index];
    setCurrentSlideData(slideData);
  }, [currentSlideData, hasReachMax, slides]);

  var handleFadeToPrev = function handleFadeToPrev() {
    var slideData = _extends({}, currentSlideData);

    slideData.index -= 1;

    if (hasReachMin) {
      slideData.index = maxSlideIndex;
    }

    slideData.slide = slides[slideData.index];
    setCurrentSlideData(slideData);
  };

  var handleMouseLeaveFade = function handleMouseLeaveFade() {
    setStartAutoSlide(true);
  };

  var handleMouseHoverFade = function handleMouseHoverFade() {
    setStartAutoSlide(false);
  };

  useEffect(function () {
    var Slide = slideRef.current;
    var timeoutId = setTimeout(function () {
      Slide.style = "\n        opacity: 1;\n        transition: " + transition + ";\n        ";
    }, 100);
    return function () {
      clearTimeout(timeoutId);
      Slide.style = "\n        opacity: 0;\n        ";
    };
  }, [currentSlideData]);
  useEffect(function () {
    if (autoSlide && startAutoSlide) {
      var intervalId = setInterval(function () {
        handleFadeToNext();
      }, autoSlide.interval || 5000);
      return function () {
        clearInterval(intervalId);
      };
    }
  }, [handleFadeToNext, autoSlide, startAutoSlide]);
  useEffect(function () {
    var Slide = slideRef.current;
    var allFocusingElements = Slide.querySelectorAll('a, button, input, textarea, area');
    allFocusingElements.forEach(function (element) {
      if (autoSlide && autoSlide.pauseOnTab) {
        element.addEventListener('focus', handleMouseHoverFade);
        element.addEventListener('blur', handleMouseLeaveFade);
      }
    });
  }, [currentSlideData]);

  var _useSwipe = useSwipe(sliderRef.current),
      state = _useSwipe[0];

  useEffect(function () {
    if (state.movedLeft) {
      handleFadeToNext();
    }

    if (state.movedRight) {
      handleFadeToPrev();
    }
  }, [state]);
  var componentProps = {
    Styled: {
      flexBasis: '100%',
      fader: 'true'
    },
    Dots: {
      data: {
        dots: dotsList,
        currentDot: currentSlideData.index
      },
      onClick: handleDotClick
    },
    Buttons: [{
      isPrev: true,
      onClick: handleFadeToPrev
    }, {
      isPrev: false,
      onClick: handleFadeToNext
    }],
    Slide: {
      data: {
        slide: currentSlideData.slide
      }
    }
  };
  return /*#__PURE__*/React__default.createElement(Styled$1, _extends({}, componentProps.Styled, {
    ref: sliderRef,
    onMouseOver: autoSlide && autoSlide.pauseOnHover ? handleMouseHoverFade : null,
    onMouseLeave: autoSlide && autoSlide.pauseOnHover ? handleMouseLeaveFade : null
  }), buttons && /*#__PURE__*/React__default.createElement(Button, componentProps.Buttons[0]), /*#__PURE__*/React__default.createElement("main", {
    className: "content"
  }, /*#__PURE__*/React__default.createElement("div", {
    className: "center"
  }, /*#__PURE__*/React__default.createElement(Slide, _extends({
    ref: slideRef,
    style: {
      opacity: 0
    }
  }, componentProps.Slide))), dots && /*#__PURE__*/React__default.createElement(Dots, _extends({
    style: {
      transform: 'translateX(-50%)',
      position: 'absolute',
      bottom: '8px',
      left: '50%',
      zIndex: '10'
    }
  }, componentProps.Dots))), buttons && /*#__PURE__*/React__default.createElement(Button, componentProps.Buttons[1]));
}

Fader.defaultProps = {
  buttons: false,
  dots: true,
  transition: '0.5s ease-in',
  autoSlide: {
    interval: 3800
  }
};
Fader.propTypes = {
  dots: propTypes.bool,
  buttons: propTypes.bool,
  transition: propTypes.string,
  children: propTypes.oneOfType([propTypes.arrayOf(propTypes.element), propTypes.element]).isRequired,
  autoSlide: propTypes.oneOfType([propTypes.bool, propTypes.shape({
    pauseOnHover: propTypes.bool,
    interval: propTypes.number
  })])
};

var ThemeProvider = function ThemeProvider(_ref) {
  var children = _ref.children,
      theme = _ref.theme;
  return /*#__PURE__*/React__default.createElement(ThemeProvider$1, {
    theme: theme
  }, children);
};

export { Fader, Slider, ThemeProvider };
//# sourceMappingURL=index.modern.js.map
